#
# Conditional build:
%bcond_without	apidocs		# API documentation
%bcond_without	static_libs	# static library
%bcond_with	libsoup		# libsoup instead of curl
%bcond_with	selinux		# selinux module for system-helper
%bcond_without	system_bwrap	# system bubblewrap
%bcond_without	malcontent	# parental control support via libmalcontent

Summary:	Application deployment framework for desktop apps
Summary(pl.UTF-8):	Szkielet do wdrażania aplikacji desktopowych
Name:		flatpak
Version:	1.16.0
Release:	2
License:	LGPL v2+
Group:		Applications
#Source0Download: https://github.com/flatpak/flatpak/releases/
Source0:	https://github.com/flatpak/flatpak/releases/download/%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	bdf866646fb312a341f84669f625488b
URL:		https://flatpak.org/
BuildRequires:	AppStream-devel >= 1.0
BuildRequires:	bison
%{?with_system_bwrap:BuildRequires:	bubblewrap >= 0.10.0}
%{!?with_libsoup:BuildRequires:	curl-devel >= 7.29.0}
BuildRequires:	dconf-devel >= 0.26
BuildRequires:	docbook-dtd45-xml
BuildRequires:	docbook-style-xsl-nons
# or libelf >= 0.8.12
BuildRequires:	elfutils-devel
BuildRequires:	gdk-pixbuf2-devel >= 2.0
BuildRequires:	gettext-tools >= 0.18.2
BuildRequires:	glib2-devel >= 1:2.60
BuildRequires:	gobject-introspection-devel >= 1.40.0
BuildRequires:	gpgme-devel >= 1:1.8.0
BuildRequires:	gtk-doc >= 1.20
BuildRequires:	json-glib-devel >= 1.0
BuildRequires:	libarchive-devel >= 2.8.0
BuildRequires:	libcap-devel
BuildRequires:	libfuse3-devel >= 3.1.1
%{?with_malcontent:BuildRequires:	libmalcontent-devel >= 0.5.0}
BuildRequires:	libseccomp-devel
%{?with_libsoup:BuildRequires:	libsoup-devel >= 2.4}
BuildRequires:	libxml2-devel >= 2.4
BuildRequires:	libxslt-progs
BuildRequires:	meson >= 0.53.0
BuildRequires:	ninja >= 1.5
BuildRequires:	ostree-devel >= 2020.8
BuildRequires:	pkgconfig >= 1:0.24
BuildRequires:	polkit-devel >= 0.98
BuildRequires:	python3 >= 1:3
BuildRequires:	python3-pyparsing
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 2.042
BuildRequires:	sed >= 4.0
# /usr/share/selinux/devel/Makefile
%{?with_selinux:BuildRequires:	selinux-policy-devel}
BuildRequires:	systemd-devel
BuildRequires:	tar >= 1:1.22
BuildRequires:	wayland-devel >= 1.15
BuildRequires:	wayland-protocols >= 1.32
BuildRequires:	xdg-dbus-proxy >= 0.1.0
BuildRequires:	xmlto
BuildRequires:	xorg-lib-libXau-devel
BuildRequires:	xz
BuildRequires:	zstd-devel >= 0.8.1
# no switch to disable
%{!?with_malcontent:BuildConflicts:	libmalcontent-devel}
%{?with_system_bwrap:Requires:	bubblewrap >= 0.10.0}
Requires:	libfuse3 >= 3.1.1
Requires:	libfuse3-tools >= 3.1.1
Requires:	ostree >= 2020.8
Requires:	polkit >= 0.98
Requires:	xdg-dbus-proxy >= 0.1.0
Obsoletes:	xdg-app < 0.6.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Application deployment framework for desktop apps.

%description -l pl.UTF-8
Szkielet do wdrażania aplikacji desktopowych.

%package libs
Summary:	Shared flatpak library
Summary(pl.UTF-8):	Biblioteka współdzielona flatpak
Group:		Libraries
%{!?with_libsoup:Requires:	curl-libs >= 7.29.0}
Requires:	dconf >= 0.26
Requires:	glib2 >= 1:2.60
Requires:	gpgme >= 1:1.8.0
%{?with_malcontent:Requires:	libmalcontent >= 0.5.0}
Requires:	libxml2 >= 2.4
Requires:	ostree >= 2020.8
Requires:	zstd >= 0.8.1

%description libs
Shared flatpak library.

%description libs -l pl.UTF-8
Biblioteka współdzielona flatpak.

%package devel
Summary:	Header files for flatpak library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki flatpak
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	glib2-devel >= 1:2.60
Requires:	ostree-devel >= 2020.8

%description devel
Header files for flatpak library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki flatpak.

%package static
Summary:	Static flatpak library
Summary(pl.UTF-8):	Biblioteka statyczna flatpak
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static flatpak library.

%description static -l pl.UTF-8
Biblioteka statyczna flatpak.

%package apidocs
Summary:	API documentation for flatpak library
Summary(pl.UTF-8):	Dokumentacja API biblioteki flatpak
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for flatpak library.

%description apidocs -l pl.UTF-8
Dokumentacja API biblioteki flatpak.

%package -n bash-completion-flatpak
Summary:	Bash completion for flatpak command
Summary(pl.UTF-8):	Bashowe uzupełnianie parametrów polecenia flatpak
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion >= 2
Obsoletes:	bash-completion-xdg-app < 0.6.0
BuildArch:	noarch

%description -n bash-completion-flatpak
Bash completion for flatpak command.

%description -n bash-completion-flatpak -l pl.UTF-8
Bashowe uzupełnianie parametrów polecenia flatpak.

%package -n fish-completion-flatpak
Summary:	Fish completion for flatpak commands
Summary(pl.UTF-8):	Dopełnianie składni poleceń flatpak w fish
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	fish
BuildArch:	noarch

%description -n fish-completion-flatpak
Fish completion for flatpak commands.

%description -n fish-completion-flatpak -l pl.UTF-8
Dopełnianie składni poleceń flatpak w fish.

%package -n zsh-completion-flatpak
Summary:	ZSH completion for flatpak command
Summary(pl.UTF-8):	Uzupełnianie parametrów polecenia flatpak w powłoce ZSH
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	zsh
BuildArch:	noarch

%description -n zsh-completion-flatpak
ZSH completion for flatpak command.

%description -n zsh-completion-flatpak -l pl.UTF-8
Uzupełnianie parametrów polecenia flatpak w powłoce ZSH.

%prep
%setup -q

%{__sed} -i -e '1s,/usr/bin/env python3,%{__python3},' scripts/flatpak-{bisect,coredumpctl}

%build
%meson \
	%{!?with_static_libs:--default-library=shared} \
	-Ddconf=enabled \
	-Ddbus_config_dir=%{_datadir}/dbus-1/system.d \
	-Ddocbook_docs=enabled \
	-Dgir=enabled \
	-Dgtkdoc=%{__enabled_disabled apidocs} \
	-Dlibzstd=enabled \
	-Dmalcontent=enabled \
	-Dman=enabled \
	-Dseccomp=enabled \
	-Dselinux_module=%{__enabled_disabled selinux} \
	%{?with_system_bwrap:-Dsystem_bubblewrap=/usr/bin/bwrap} \
	-Dsystem_dbus_proxy=/usr/bin/xdg-dbus-proxy \
	-Dsystem_fusermount=/usr/bin/fusermount3 \
	-Dsystem_helper=enabled \
	-Dsystemd=enabled \
	-Dsystemdsystemunitdir=%{systemdunitdir} \
	-Dtests=false \
	-Dwayland_security_context=enabled

%meson_build

%install
rm -rf $RPM_BUILD_ROOT

%meson_install

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc NEWS README.md SECURITY.md
%doc %{_docdir}/flatpak
%attr(755,root,root) %{_bindir}/flatpak
%attr(755,root,root) %{_bindir}/flatpak-bisect
%attr(755,root,root) %{_bindir}/flatpak-coredumpctl
%if %{without system_bwrap}
%attr(755,root,root) %{_libexecdir}/flatpak-bwrap
%endif
%attr(755,root,root) %{_libexecdir}/flatpak-oci-authenticator
%attr(755,root,root) %{_libexecdir}/flatpak-portal
%attr(755,root,root) %{_libexecdir}/flatpak-session-helper
%attr(755,root,root) %{_libexecdir}/flatpak-system-helper
%attr(755,root,root) %{_libexecdir}/flatpak-validate-icon
%attr(755,root,root) %{_libexecdir}/revokefs-fuse
%attr(755,root,root) /etc/profile.d/flatpak.csh
%attr(755,root,root) /etc/profile.d/flatpak.sh
%{_datadir}/dbus-1/services/org.freedesktop.Flatpak.service
%{_datadir}/dbus-1/system-services/org.freedesktop.Flatpak.SystemHelper.service
%{_datadir}/dbus-1/system.d/org.freedesktop.Flatpak.SystemHelper.conf
%{_datadir}/dbus-1/services/org.flatpak.Authenticator.Oci.service
%{_datadir}/dbus-1/services/org.freedesktop.portal.Flatpak.service
%{_datadir}/polkit-1/actions/org.freedesktop.Flatpak.policy
%{_datadir}/polkit-1/rules.d/org.freedesktop.Flatpak.rules
%{systemdunitdir}/flatpak-system-helper.service
%{systemduserunitdir}/flatpak-oci-authenticator.service
%{systemduserunitdir}/flatpak-portal.service
%{systemduserunitdir}/flatpak-session-helper.service
%attr(755,root,root) %{_prefix}/lib/systemd/system-environment-generators/60-flatpak-system-only
%attr(755,root,root) %{_prefix}/lib/systemd/user-environment-generators/60-flatpak
%{_prefix}/lib/sysusers.d/flatpak.conf
%{systemdtmpfilesdir}/flatpak.conf
%dir %{_datadir}/flatpak
%dir %{_datadir}/flatpak/triggers
%attr(755,root,root) %{_datadir}/flatpak/triggers/*.trigger
%{_mandir}/man1/flatpak*.1*
%{_mandir}/man5/flatpak-flatpakref.5*
%{_mandir}/man5/flatpak-flatpakrepo.5*
%{_mandir}/man5/flatpak-installation.5*
%{_mandir}/man5/flatpak-metadata.5*
%{_mandir}/man5/flatpak-remote.5*
%{_mandir}/man5/flatpakref.5*
%{_mandir}/man5/flatpakrepo.5*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libflatpak.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libflatpak.so.0
%{_libdir}/girepository-1.0/Flatpak-1.0.typelib
%{_datadir}/dbus-1/interfaces/org.freedesktop.Flatpak.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.Flatpak.Authenticator.xml
%{_datadir}/dbus-1/interfaces/org.freedesktop.portal.Flatpak.xml

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libflatpak.so
%{_includedir}/flatpak
%{_datadir}/gir-1.0/Flatpak-1.0.gir
%{_pkgconfigdir}/flatpak.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libflatpak.a
%endif

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%{_gtkdocdir}/flatpak
%endif

%files -n bash-completion-flatpak
%defattr(644,root,root,755)
%{bash_compdir}/flatpak

%files -n fish-completion-flatpak
%defattr(644,root,root,755)
%{fish_compdir}
%{_datadir}/fish/vendor_conf.d/flatpak.fish

%files -n zsh-completion-flatpak
%defattr(644,root,root,755)
%{zsh_compdir}/_flatpak
%changelog
* Sat Jul 12 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/flatpak.git;a=log;h=master

* Sat Jul 12 2025 Arkadiusz Miśkiewicz <arekm@maven.pl> c958c38
- Release 2 (by relup.sh)

* Sun Apr 13 2025 Jakub Bogusz <qboosh@pld-linux.org> 5fd81bf
- explicit fusermount patch

* Mon Mar 17 2025 Jakub Bogusz <qboosh@pld-linux.org> f92501c
- updated to 1.16.0

* Sat Sep 14 2024 Jan Palus <atler@pld-linux.org> 9678113
- drop api reference coming from dist when building without apidocs

* Sat Sep 14 2024 Jan Palus <atler@pld-linux.org> 60f5fac
- don't guard --enable-documentation with apidocs

* Sat Sep 14 2024 Jakub Bogusz <qboosh@pld-linux.org> 564a797
- updated to 1.14.10 (fixes CVE-2024-42472)

* Fri Apr 19 2024 Jan Palus <atler@pld-linux.org> fb8fe8b
- remove missing patch dropped from spec in 65dc537

* Fri Apr 19 2024 Jan Palus <atler@pld-linux.org> b2cd98b
- BR: bison

* Thu Apr 18 2024 Jakub Bogusz <qboosh@pld-linux.org> 163a25a
- updated to 1.14.6 (fixes CVE-2024-32462)

* Tue Mar 19 2024 Jan Rękorajski <baggins@pld-linux.org> 0ab4dc7
- Release 2 (by relup.sh)

* Sun Mar 03 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 2e1a973
- updated to 1.14.5
- bump BR for AppStream

* Tue May 16 2023 Jakub Bogusz <qboosh@pld-linux.org> 65dc537
- updated to 1.14.4 (fixes CVE-2023-28100, CVE-2023-28101)

* Sun Sep 18 2022 Jakub Bogusz <qboosh@pld-linux.org> 9b6b703
- updated dependencies, added libsoup bcond (package now defaults to curl)

* Sun Sep 18 2022 Jakub Bogusz <qboosh@pld-linux.org> b5e6e5b
- added missing patch (missing files from git), rebuild autotools to fix missing gtk-docs

* Thu Sep 15 2022 Łukasz Maśko <lmasko@pld-linux.org> 17b9f5b
- Up to 0.14.0. Maybe KDE app will not crash at startup any more.

* Thu Apr 14 2022 Jakub Bogusz <qboosh@pld-linux.org> 85951c5
- updated to 1.12.7

* Wed Dec 08 2021 Jakub Bogusz <qboosh@pld-linux.org> 53079b5
- updated to 1.12.2

* Wed Dec 08 2021 Jakub Bogusz <qboosh@pld-linux.org> e96c0c6
- updated to 1.10.5

* Sat Sep 18 2021 Jakub Bogusz <qboosh@pld-linux.org> e40f47e
- updated to 1.10.3

* Sat Mar 27 2021 Jakub Bogusz <qboosh@pld-linux.org> a984350
- updated to 1.10.2
- completions packages as noarch

